//CITS to normal STM format
//v3.3 (2001)
//Ian Scott (ian@norcimo.com)

/* You may freely copy, redistribute and modify this code for non-commercial purposes provided you acknowledge the original author and make freely available, under identical conditions and restrictions, all code thus produced  */

//This programme is designed to compliment Dave Spence's STM2BMP conversion programme

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

enum BOOL{FALSE,TRUE};

char* ReadInt(char *Prompt,char *ErrMess);
int paramcopy(char* num, char* cit);

int main()
{
int ns,np,nl,p,l,opt,looping,value,value2,v1,v2;
char tpfn[15],tsfn[15],stmn[25],buf[1],fno[6],citsno[6],option[6],citsno2[6];
ifstream tpf,tsf;
ofstream stm;
cout<<"CITS to STM image format conversion programme"<<endl;
cout<<endl<<"Version 3.3"<<endl;
cout<<endl<<"Ian Scott 2001"<<endl<<endl;
//Find out which file to work with
strcpy(fno,ReadInt("Enter filenumber of spectroscopy file:","Please enter a number"));
cout<<endl;
strcpy(tpfn,"tp");
strcat(tpfn,fno);
strcpy(tsfn,"ts");
strcat(tsfn,fno);
tpf.open(tpfn,ios::in|ios::binary);
if (!tpf)
	{
	cout<<"Can't open parameter file"<<endl<<"Doh!"<<endl;
	return 1;
	}
tsf.open(tsfn,ios::in|ios::binary);
if (!tsf)
	{
	cout<<"Can't open spectroscopy file"<<endl<<"Doh!"<<endl;
	tpf.close();
	return 1;
	}
//move through parameter file to number of points
tpf.seekg(30,ios::beg);
tpf.read(buf,2);
np=buf[0]*256+buf[1];
//move to number of lines
tpf.seekg(34,ios::beg);
tpf.read(buf,2);
nl=buf[0]*256+buf[1];
//move to number of spectroscopy steps
tpf.seekg(166,ios::beg);
tpf.read(buf,2);
ns=buf[0]*256+buf[1];
//Don't need the parameter file any more, so close it.
tpf.close();
do
{
cout<<"1. Single CITS image"<<endl<<endl;
cout<<"2. Difference CITS image"<<endl<<endl;
strcpy(option,ReadInt("Please enter option:","Option must be a number!"));
opt=atoi(option);
if (opt<1 || opt>2)
	{
	cout<<"Options are 1 to 2!"<<endl;
	}
}while(opt<1 || opt>2);

switch(opt)
{
case 1: //single image

//Find out which CITS image to convert
do
	{
	cout<<"CITS images available: 0-"<<ns-1<<endl;
	strcpy(citsno,ReadInt("Enter the number of the CITS image:","Please enter a number"));
	if (atoi(citsno)>ns)
		cout<<"Not in range!"<<endl<<endl;
	}while(atoi(citsno)>=ns);
cout<<endl;
strcpy(stmn,"tz");
strcat(stmn,fno);
strcat(stmn,"_");
strcat(stmn,citsno);
stm.open(stmn,ios::out|ios::binary);
if (!stm)
	{
	cout<<"Can't open the output file"<<endl<<"Doh!"<<endl;
	tsf.close();
	return 1;
	}
for (l=1;l<=nl;l++) //loop through lines
	{
	for (p=1;p<=np;p++) //loop through points
		{

tsf.seekg((l-1)*ns*np*2+(p-1)*ns*2+atoi(citsno)*2,ios::beg);
//move to the correct spectroscopy
						      //value
		tsf.read(buf,2);
		stm.write(buf,2);
		}
	}
//close the files
tsf.close();
stm.close();
break;

case 2: //difference image

//find out the first cits image number
do
	{
	cout<<"CITS images available: 0-"<<ns-1<<endl;
	strcpy(citsno,ReadInt("Enter the number of the first CITS image:","Please enter a number"));
	if (atoi(citsno)>ns)
		cout<<"Not in range!"<<endl<<endl;
	}while(atoi(citsno)>=ns);
cout<<endl;
//find out the cits image to subtract
do
	{
	cout<<"CITS images available: 0-"<<ns-1<<endl;
	strcpy(citsno2,ReadInt("Enter the number of the CITS image to subtract:","Please enter a number"));
	if (atoi(citsno2)>ns)
		cout<<"Not in range!"<<endl<<endl;
	}while(atoi(citsno2)>=ns);
cout<<endl;
strcpy(stmn,"tz");
strcat(stmn,fno);
strcat(stmn,"_");
strcat(stmn,citsno);
strcat(stmn,"-");
strcat(stmn,citsno2);
stm.open(stmn,ios::out|ios::binary);
if (!stm)
	{
	cout<<"Can't open the output file"<<endl<<"Doh!"<<endl;
	tsf.close();
	return 1;
	}
for (l=1;l<=nl;l++) //loop through lines
	{
	for (p=1;p<=np;p++) //loop through points
		{

		tsf.seekg((l-1)*ns*np*2+(p-1)*ns*2+atoi(citsno)*2,ios::beg);
		for (looping=0;looping<=1;looping++)
			{
			tsf.read(buf,1);
			value=buf[0];
			if (value<0)
				{
				value=value&127;
				value+=128;
				}
			if (looping)
				{
				value2+=value;
				}
			else
				{
				value2=value*256;
				}
			}
		v1=value2;

tsf.seekg((l-1)*ns*np*2+(p-1)*ns*2+atoi(citsno2)*2,ios::beg);
		for (looping=0;looping<=1;looping++)
			{
			tsf.read(buf,1);
			value=buf[0];
			if (value<0)
				{
				value=value&127;
				value+=128;
				}
			if (looping)
				{
				value2+=value;
				}
			else
				{
				value2=value*256;
				}
			}
		v2=value2;
		value=v1-v2;
		v1=value&65280;
		v1/=256;
		v2=value&255;
		buf[0]=v1;
		buf[1]=v2;
		stm.write(buf,2);
		}
	}
tsf.close();
stm.close();
break;
}//end select

p=paramcopy(fno,stmn);
if (p)
	{
	cout<<"Couldn't copy parameter file!";
	return 1;
	}
stmn[0]='t';
cout<<"Done. File created as "<<stmn<<endl;
cout<<"Parameter file copied"<<endl;
}

char* ReadInt(char *Prompt,char *ErrMess)
//Displays Prompt and then enters an integer,displaying ErrMess if
//an integer was not read
{
char Input[6];
BOOL Valid;
int Value;
cout<<Prompt;
do
	{
	cin>>ws; //clear white space
	cin.getline(Input,5);
	Valid=TRUE;
	for (int Ch=0;Ch<strlen(Input);Ch++)
		if (!isdigit(Input[Ch])) //is the character not a digit
			{
				Valid=FALSE;
			}//End if
	if (!Valid)
		cout<<ErrMess<<endl; //Display the error message
	}while(!Valid);
return Input;
}//End int ReadInt(..)


int paramcopy(char* num, char* cit)
{
ifstream oldtp;
ofstream newtp;

char oldn[15],newn[15],buf[1],temp[15];
int t;

strcpy(oldn,"tp");
strcat(oldn,num);
strcpy(newn,"tp");
for (t=2;t<=strlen(cit);t++)
	{
	temp[t-2]=cit[t];
	}
strcat(newn,temp);

oldtp.open(oldn,ios::in|ios::binary);
if (!oldtp)
	{
	cout<<"Can't open parameter file. Doh!"<<endl;
	return 1;
	}
newtp.open(newn,ios::out|ios::binary);
if (!newtp)
	{
	cout<<"Can't open new parameter file. Doh!"<<endl;
	oldtp.close();
	return 1;
	}
while (!oldtp.eof())
	{
	oldtp.read(buf,1);
	newtp.write(buf,1);
	}
return 0;
}
